// RC5 demo worker thread.

class RC5test implements Runnable {
  RC5demo Host;

  RC5test(RC5demo host)
  {
    Host = host;
  }

  public void run()
  {
    // cyphertext and iv data from the RSA test pseudo-contest "RSA-32/12/8-test"
    long ct = 0x496def29b74be041L;
    long iv = 0xc41f78c1f839a5d9L;
    RC5 rc5 = new RC5_32_12_8();
    byte[] key = new byte[rc5.keySize()];
    // uncommenting these lines gives the correct key, we'll just start searching close to it
    //key[0] = (byte)0x82;
    //key[1] = (byte)0xe5;
    //key[2] = (byte)0x1b;
    key[3] = (byte)0x9f;
    key[4] = (byte)0x9c;
    key[5] = (byte)0xc7;
    key[6] = (byte)0x18;
    key[7] = (byte)0xf9;
    long keys = 0;
    long start = System.currentTimeMillis();
    kloop: while (true) {
      rc5.setup(key);
      long pt = rc5.decrypt(ct) ^ iv;
      keys++;
      // this represents the string "The unkn"
      if (pt == 0x6e6b6e7520656854L) {
        // key has been found, but for this demo we'll keep searching
        //break;
      }
      int i = 0;
      while (++key[i] == 0) {
        i++;
        if (i >= 1) {
          long now = System.currentTimeMillis();
          // terminate the demo after a reasonable amount of time
          if (now - start >= 30000) {
            break kloop;
          }
          if (i >= 2) {
            Host.updateStats(keys, now - start, false);
          }
        }
        if (i >= key.length) {
          break kloop;
        }
      }
    }
    long end = System.currentTimeMillis();
    Host.updateStats(keys, end - start, true);
  }
}
